=== debian/changelog ===
rabit (0.0~git20200628.74bf00a-2) unstable; urgency=medium

  * Stop tracking C++ symbols.

 -- Mo Zhou <lumin@debian.org>  Mon, 26 Oct 2020 20:23:30 +0800

rabit (0.0~git20200628.74bf00a-1) unstable; urgency=medium

  * Rollback to upstream snapshot 0.0~git20200628.74bf00a,
    in order to align with the xgboost/v1.2.1 rabit submodule pointer.
  * Refresh symbols control file.
  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Sun, 25 Oct 2020 15:21:42 +0800

rabit (0.0~git20200805.4acdd7c-1) UNRELEASED; urgency=medium

  * New upstream version 0.0~git20200805.4acdd7c
  * Change maintainer mail address into debian-ai@l.d.o
  * Bump debhelper compat level to 13.
  * Fix hardening issue caused by typo.
  * Add symbols control file to track symbol changes.
  * Override a couple of lintian INFO for librabit0.

 -- Mo Zhou <lumin@debian.org>  Sun, 20 Sep 2020 15:25:31 +0800

rabit (0.0~git20200127.2f7fcff-1) experimental; urgency=medium

  * Initial release. (Closes: #958517)

 -- Mo Zhou <lumin@debian.org>  Tue, 14 Jul 2020 15:29:35 +0800
