=== debian/control ===
Source: rabit
Section: science
Homepage: https://github.com/dmlc/rabit/
Priority: optional
Standards-Version: 4.5.0
Vcs-Git: https://salsa.debian.org/deeplearning-team/rabit.git
Vcs-Browser: https://salsa.debian.org/deeplearning-team/rabit
Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
Uploaders: Mo Zhou <lumin@debian.org>
Build-Depends: debhelper-compat (= 13), cmake, libdmlc-dev
Rules-Requires-Root: no

Package: librabit-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, librabit0 (= ${binary:Version}),
Description: Reliable Allreduce and Broadcast Interface (dev)
 rabit is a light weight library that provides a fault tolerant interface of
 Allreduce and Broadcast. It is designed to support easy implementations of
 distributed machine learning programs, many of which fall naturally under the
 Allreduce abstraction. The goal of rabit is to support portable , scalable and
 reliable distributed machine learning programs.
 .
 This package contains the development files.

Package: librabit0
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: Reliable Allreduce and Broadcast Interface (libs)
 rabit is a light weight library that provides a fault tolerant interface of
 Allreduce and Broadcast. It is designed to support easy implementations of
 distributed machine learning programs, many of which fall naturally under the
 Allreduce abstraction. The goal of rabit is to support portable , scalable and
 reliable distributed machine learning programs.
 .
 This package contains the shared object.
